package net.sourceforge.nattable.edit.action;

import net.sourceforge.nattable.NatTable;
import net.sourceforge.nattable.edit.command.EditSelectionCommand;
import net.sourceforge.nattable.ui.action.IKeyAction;
import net.sourceforge.nattable.ui.matcher.LetterOrDigitKeyEventMatcher;

import org.eclipse.swt.events.KeyEvent;

public class KeyEditAction implements IKeyAction {
    
    private final boolean useAdjustOnMultiCellEdit;

    public KeyEditAction() {
        this(false);
    }

	public KeyEditAction(boolean useAdjustOnMultiCellEdit) {
        this.useAdjustOnMultiCellEdit = useAdjustOnMultiCellEdit;
    }

    public void run(NatTable natTable, KeyEvent event) {
		natTable.doCommand(new EditSelectionCommand(natTable, natTable.getConfigRegistry(), convertCharToCharacterObject(event), useAdjustOnMultiCellEdit));
	}

    protected Character convertCharToCharacterObject(KeyEvent event) {
        Character character = null;
		if (LetterOrDigitKeyEventMatcher.isLetterOrDigit(event.character)) {
			character = Character.valueOf(event.character);
		}
        return character;
    }
}