package net.sourceforge.nattable.edit.editor;

/**
 * Abstract implementation of IEditErrorHandler that by default calls
 * the underlying IEditErrorHandler to handle the error.
 */
public abstract class AbstractEditErrorHandler implements IEditErrorHandler {

	protected IEditErrorHandler underlyingErrorHandler;
	
	public AbstractEditErrorHandler(IEditErrorHandler underlyingErrorHandler) {
		this.underlyingErrorHandler = underlyingErrorHandler;
	}
	
	public void removeError(ICellEditor cellEditor) {
		if (underlyingErrorHandler != null) {
			underlyingErrorHandler.removeError(cellEditor);
		}
	}
	
	public void displayError(ICellEditor cellEditor, Exception e) {
		if (underlyingErrorHandler != null) {
			underlyingErrorHandler.displayError(cellEditor, e);
		}
	}
}
