package net.sourceforge.nattable.extension.glazedlists.groupBy;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Observable;

import net.sourceforge.nattable.sort.SortDirectionEnum;

public class GroupByModel extends Observable {

	private List<Integer> groupByColumnIndexes = new ArrayList<Integer>();
	private Map<Integer, SortDirectionEnum> sortDirectionMap = new HashMap<Integer, SortDirectionEnum>();
	
	public boolean addGroupByColumnIndex(int columnIndex) {
		if (!groupByColumnIndexes.contains(columnIndex)) {
			groupByColumnIndexes.add(columnIndex);
			setChanged();
			notifyObservers();
			return true;
		} else {
			// unchanged
			return false;
		}
	}
	
	public boolean removeGroupByColumnIndex(int columnIndex) {
		if (groupByColumnIndexes.contains(columnIndex)) {
			groupByColumnIndexes.remove(Integer.valueOf(columnIndex));
			sortDirectionMap.remove(columnIndex);
			setChanged();
			notifyObservers();
			return true;
		} else {
			// unchanged;
			return false;
		}
	}
	
	public void clearGroupByColumnIndexes() {
		groupByColumnIndexes.clear();
		sortDirectionMap.clear();
		setChanged();
		notifyObservers();
	}

	public List<Integer> getGroupByColumnIndexes() {
		return groupByColumnIndexes;
	}
	
	public SortDirectionEnum getSortDirection(int columnIndex) {
		return sortDirectionMap.get(columnIndex);
	}
	
}
