package net.sourceforge.nattable.extension.glazedlists.groupBy;

import java.util.Comparator;
import java.util.List;

import net.sourceforge.nattable.config.DefaultComparator;
import net.sourceforge.nattable.data.IColumnAccessor;
import ca.odell.glazedlists.TreeList;

public class GroupByTreeFormat<T> implements TreeList.Format<Object> {

	private final GroupByModel model;
	private final IColumnAccessor<T> columnAccessor;

	public GroupByTreeFormat(GroupByModel model, IColumnAccessor<T> columnAccessor) {
		this.model = model;
		this.columnAccessor = columnAccessor;
	}

	public void getPath(List<Object> path, Object element) {
		for (int columnIndex : model.getGroupByColumnIndexes()) {
			Object columnValue = columnAccessor.getDataValue((T) element, columnIndex);
			path.add(new GroupByObject(columnValue));
		}

		path.add(element);
	}

	public boolean allowsChildren(Object element) {
		return true;
	}

	public Comparator<Object> getComparator(int depth) {
		return DefaultComparator.getInstance();
	}
	
}
