package net.sourceforge.nattable.filterrow.event;

import net.sourceforge.nattable.NatTable;
import net.sourceforge.nattable.config.IConfigRegistry;
import net.sourceforge.nattable.filterrow.FilterRowPainter;
import net.sourceforge.nattable.layer.LabelStack;
import net.sourceforge.nattable.layer.cell.LayerCell;
import net.sourceforge.nattable.util.ObjectUtils;

import org.eclipse.swt.events.MouseEvent;

public class ClearFilterIconMouseEventMatcher extends FilterRowMouseEventMatcher {

	private final FilterRowPainter filterRowPainter;

	public ClearFilterIconMouseEventMatcher(FilterRowPainter filterRowPainter) {
		this.filterRowPainter = filterRowPainter;
	}
	
	@Override
	public boolean matches(NatTable natTable, MouseEvent event, LabelStack regionLabels) {
		LayerCell cell = natTable.getCellByPosition(natTable.getColumnPositionByX(event.x), natTable.getRowPositionByY(event.y));
		
		if (cell == null)
			return false;
		
		IConfigRegistry configRegistry = natTable.getConfigRegistry();
		
		boolean clearFilterIconClicked = false;
		
		if (ObjectUtils.isNotNull(cell.getDataValue())) {
			clearFilterIconClicked = filterRowPainter.containsRemoveFilterImage(event.x, event.y, cell, configRegistry);
		}
		return (super.matches(natTable, event, regionLabels) && clearFilterIconClicked);		
	}
}
