package net.sourceforge.nattable.hideshow.event;

import java.util.ArrayList;
import java.util.Collection;

import net.sourceforge.nattable.coordinate.PositionUtil;
import net.sourceforge.nattable.coordinate.Range;
import net.sourceforge.nattable.layer.ILayer;
import net.sourceforge.nattable.layer.event.RowStructuralChangeEvent;
import net.sourceforge.nattable.layer.event.StructuralDiff;
import net.sourceforge.nattable.layer.event.StructuralDiff.DiffTypeEnum;

public class ShowRowPositionsEvent extends RowStructuralChangeEvent {

	public ShowRowPositionsEvent(ILayer layer, Collection<Integer> rowPositions) {
		super(layer, PositionUtil.getRanges(rowPositions));
	}
	
	// Copy constructor
	protected ShowRowPositionsEvent(ShowRowPositionsEvent event) {
		super(event);
	}
	
	public Collection<StructuralDiff> getRowDiffs() {
		Collection<StructuralDiff> rowDiffs = new ArrayList<StructuralDiff>();

		int offset = 0;
		for (Range range : getRowPositionRanges()) {
			rowDiffs.add(new StructuralDiff(DiffTypeEnum.ADD, new Range(range.start - offset, range.start - offset), range));
			offset += range.size();
		}

		return rowDiffs;
	}

	public ShowRowPositionsEvent cloneEvent() {
		return new ShowRowPositionsEvent(this);
	}
	
	@Override
	public boolean convertToLocal(ILayer localLayer) {
		super.convertToLocal(localLayer);
		return true;
	}
}
